image: registry.gitlab.com/go_noob/cpp/pro/cpp_repo_example

stages:
  - build
  - install
  - test
  - deploy

cmake_build:
  stage: build
  script:
    - mkdir $CI_PROJECT_DIR/build
    - cd $CI_PROJECT_DIR/build
    - cmake -DCMAKE_BUILD_type=Debug -DCMAKE_INSTALL_PREFIX=$CI_PROJECT_DIR/install ..
    - make -j 4
  artifacts:
    untracked: false
    expire_in: 7 days
    paths:
      - build

cpplint:
  stage: build
  script:
    - cd $CI_PROJECT_DIR/materials
    - chmod +x ./cpplint_run.sh
    - ./cpplint_run.sh

cppcheck:
  stage: build
  script:
    - cd $CI_PROJECT_DIR/materials
    - chmod +x ./cppcheck_run.sh
    - ./cppcheck_run.sh

coverage:
  stage: build
  script:
    - cd $CI_PROJECT_DIR/materials
    - chmod +x ./coverage.sh
    - ./coverage.sh
  artifacts:
    untracked: false
    expire_in: 1 days
    paths:
      - coverage_builds/html

doxygen:
  stage: build
  script:
    - cd $CI_PROJECT_DIR/materials
    - chmod +x ./doxygen_run.sh
    - ./doxygen_run.sh
  artifacts:
    untracked: false
    expire_in: 15 days
    paths:
      - doxygen_output/html

export_var:
  stage: build
  script:
    - export
    - cat /etc/os-release
    - uname -a
    - python --version
    - cmake --version
    - g++ --version
    - cppcheck --version

install:
  stage: install
  script:
    - cd $CI_PROJECT_DIR/build
    - make install
  dependencies:
    - cmake_build
  artifacts:
    untracked: false
    expire_in: 30 days
    paths:
      - install

ctest:
  stage: test
  script:
    - cd $CI_PROJECT_DIR/build
    - ctest
  dependencies:
    - cmake_build

pages:
  stage: deploy
  dependencies:
    - coverage
  script:
    - mv coverage_builds/html/ public/
  artifacts:
    untracked: false
    expire_in: 30 days
    paths:
      - public